#ifndef MAZE_H
#define MAZE_H

#include "Graphics.h"

#define MAZE_WIDTH      30
#define MAZE_HEIGHT     20
#define TILE_SIZE       20
#define WALL_WIDTH      2

#define NB_ISLANDS      2

struct STile
{
    bool    topIsActive;
    bool    leftIsActive;

    Color   topColor;
    Color   leftColor;

    bool    topVisited;
    bool    leftVisited;
};

class CMaze
{
    public:
        CMaze();

        void    draw();
        STile*  getTile(int x, int y) {return &tiles[x][y];}
        bool    checkIntersection(int x, int y, Color& c);

    private:
        void    drawWall(int x, int y, bool isHorizontal, Color c);
        STile*  chooseTrunk(bool& isHorizontal);
        STile*  chooseIsland(bool& isHorizontal);
        bool    hasWallUp(int x, int y, Color& c);
        bool    hasWallDown(int x, int y, Color& c);
        bool    hasWallLeft(int x, int y, Color& c);
        bool    hasWallRight(int x, int y, Color& c);

        STile   tiles[MAZE_WIDTH + 1][MAZE_HEIGHT + 1];
};

#endif // MAZE_H
